/***********************************************************************************
;Company : Yspring ------л㴺Ƽɷ޹˾
;File Name :YS274
;Description :  YS274_PWM_
;			PC6PC2PC1  3IO ڵ״̬ȷPWMƵ
;
;			PC6_PC2_PC1 = 000	PWM_output_400KHz
;
;			PC6_PC2_PC1 = 001	PWM_output_200kHz
;
;			PC6_PC2_PC1 = 010	PWM_output_100kHz
;
;			PC6_PC2_PC1 = 011	PWM_output_50KHz
;
;			PC6_PC2_PC1 = 100	PWM_output_10KHz
;
;			PC6_PC2_PC1 = 101	PWM_output_4KHz
;
;			PC6_PC2_PC1 = 110	PWM_output_2KHz
;
;			PC6_PC2_PC1 = 111	PWM_output_1KHz
;
************************************************************************************/

#include <YS274.h>
#include "cfg.h"

//--------------------------------------------ض

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;

//--------------------------------------------

void Init_Timer0_WDT(void); // ʼtimer0_WDT
void Init_Timer1(void);		// ʼtimer1
void Init_Timer2(void);		// ʼtimer2
void Init_GPIO(void);		// ʼIO
void Init_INT(void);		// ʼж
void Init_PWM(void);		// ʼPWM

void pwm_output(void); // PWM
void key_scan(void);   // ʼɨ

//-------------------------궨-------------------------------------

#define CLRWDT()       \
	do                 \
	{                  \
		asm("clrwdt"); \
	} while (0)
#define SLEEP()       \
	do                \
	{                 \
		asm("sleep"); \
		asm("NOP");   \
		asm("NOP");   \
		;             \
	} while (0) // asm("clrwdt");asm("clrwdt")

#define TRUE 1
#define FALSE 0

#define T2S 20	   // 2s = 20 * 100ms
#define T1S 100	   // 1s = 100 * 10ms
#define T500MS 250 // 500ms = 250 * 2ms
#define T40MS 20   // 40ms = 20 * 2ms

//------------------------------------------------------------

u8 Timer_2ms_ctr = 0x00; // 2msʱ

u8 Timer_500ms_ctr = 0x00; // 500msʱ

u16 temp_cyc;  // ڻ
u16 temp_duty; // ռձȻ

u8 temp_key = 0x00;
u8 new_key = 0x00;
u8 old_key = 0x00;
u8 key_debunce_ctr = 0x00; // ʱ
//------------------------λ---------------------------------
bit flag_t0 = 0;
bit flag_key = 0;
/********************************************************************
;
;: main
;
;˵:	
;
********************************************************************/
void main(void)
{
	CLRWDT(); // WDT

	SET_HIRC(IRCF_4M); // ڲƵѡ4MHz

	Init_Timer0_WDT(); // ʼtimer0ͿŹ
	Init_Timer1();	   // ʼtimer1
	Init_Timer2();	   // ʼtimer2
	Init_GPIO();	   // ʼIO
	Init_INT();		   // ʼж
	Init_PWM();		   // ʼPWM

	//============================ѭ================================
	while (1)
	{
		CLRWDT(); //  Ź

		if (flag_t0 == TRUE) // 2ms־ж
		{
			flag_t0 = FALSE; // 2ms־0

			key_scan();	  // ðɨ
			pwm_output(); //
		}
	}
}

/**************************************************************************************************
;: pwm_output
;
;˵: PWMÿ0.5sıһռձ( 0%  --> 100% --> 50% --> 25%  ѭ)
;
;ڲ:  
;
;ֵ: 	
;
***************************************************************************************************/
void pwm_output(void)
{
	Timer_2ms_ctr++;			 // 2msʱ1
	if (Timer_2ms_ctr >= T500MS) // 500msж
	{
		Timer_2ms_ctr = 0x00; // ʱ0

		PORTA ^= 0x04; // RA2	500msȡ

		Timer_500ms_ctr++;		  // 500ms1
		if (Timer_500ms_ctr >= 4) // 4ж
			Timer_500ms_ctr = 0;  // 500ms0

		if (Timer_500ms_ctr == 0)
		{
			PWMA0OL = 1; // PWMA0  "  "	( 100% ൱  0% ռձ)
			PWMA1OL = 1; // PWMA1  "  "
			PWMB0OL = 1; // PWMB0  "  "
			PWMB1OL = 1; // PWMB1  "  "

			temp_duty = temp_cyc; // 100%
		}
		else
		{
			PWMA0OL = 0; // PWMA0  "  "
			PWMA1OL = 0; // PWMA1  "  "
			PWMB0OL = 0; // PWMB0  "  "
			PWMB1OL = 0; // PWMB1  "  "

			if (Timer_500ms_ctr == 1) // Ƿ1
			{
				temp_duty = temp_cyc; // ռձΪ100%
			}
			else if (Timer_500ms_ctr == 2) // Ƿ2
			{
				temp_duty = temp_cyc >> 1; // ռձΪ50%
			}
			else if (Timer_500ms_ctr == 3) // Ƿ3
			{
				temp_duty = temp_cyc >> 2; // ռձΪ25%
			}
		}

		EPRA0H = temp_duty >> 8;	 // PWMA0 ռձؼĴ4λ__b<3:0>
		PRLA0L = temp_duty & 0x00ff; // PWMA0 ռձؼĴֽ

		EPRA1H = temp_duty >> 8;	 // PWMA1 ռձؼĴ4λ__b<3:0>
		PRLA1L = temp_duty & 0x00ff; // PWMA1 ռձؼĴֽ

		EPRB0H = temp_duty >> 8;	 // PWMB0 ռձؼĴ4λ__b<3:0>
		PRLB0L = temp_duty & 0x00ff; // PWMB0 ռձؼĴֽ

		EPRB1H = temp_duty >> 8;	 // PWMB1 ռձؼĴ4λ__b<3:0>
		PRLB1L = temp_duty & 0x00ff; // PWMB1 ռձؼĴֽ
	}
}
/**************************************************************************************************
;: key_scan
;
;˵:
;
;ڲ:  
;
;ֵ: 	
;
;			PC6_PC2_PC1	ڲ
;
;			PC6PC2PC1  3IO ڵ״̬ȷPWMƵ
;
;			PC6_PC2_PC1 = 000	PWM_output_400KHz
;
;			PC6_PC2_PC1 = 001	PWM_output_200kHz
;
;			PC6_PC2_PC1 = 010	PWM_output_100kHz
;
;			PC6_PC2_PC1 = 011	PWM_output_50KHz
;
;			PC6_PC2_PC1 = 100	PWM_output_10KHz
;
;			PC6_PC2_PC1 = 101	PWM_output_4KHz
;
;			PC6_PC2_PC1 = 110	PWM_output_2KHz
;
;			PC6_PC2_PC1 = 111	PWM_output_1KHz
;
***************************************************************************************************/
void key_scan(void)
{
	temp_key = (PORTC & 0x46);			 //(0x00 0xx0)
	new_key = (temp_key >> 1) & 0x03;	 //(0000 00xx)
	new_key = (temp_key >> 4) | new_key; //(0000 0xxx)

	if (old_key == new_key)
	{
		if (flag_key == FALSE)
		{
			key_debunce_ctr++;
			if (key_debunce_ctr >= T40MS)
			{
				key_debunce_ctr = 0x00;
				flag_key = TRUE;

				if (new_key < 0x06)
				{
					T1SCKSEL_16MHZ(); // Timer1 ʱԴ ѡڲʱ 16MHz
					T1PSDIV_1();	  // Timer1ʱԤƵѡ1:1 ( 16MHz  __ T = 0.0625us)

					T2SCKSEL_16MHZ(); // Timer2 ʱԴ ѡڲʱ 16MHz
					T2PSDIV_1();	  // Timer2ʱԤƵѡ1:1 ( 16MHz  __ T = 0.0625us)

					if (new_key == 0x00) //(000)
					{
						temp_cyc = 40 - 1; // PWM_output_400kHz
					}
					else if (new_key == 0x01) //(001)
					{
						temp_cyc = 80 - 1; // PWM_output_200kHz
					}
					else if (new_key == 0x02) //(010)
					{
						temp_cyc = 160 - 1; // PWM_output_100kHz
					}
					else if (new_key == 0x03) //(011)
					{
						temp_cyc = 320 - 1; // PWM_output_50kHz
					}
					else if (new_key == 0x04) //(100)
					{
						temp_cyc = 1600 - 1; // PWM_output_10kHz
					}
					else if (new_key == 0x05) //(101)
					{
						temp_cyc = 4000 - 1; // PWM_output_4kHz
					}
				}
				else
				{
					T1SCKSEL_FOSC(); // Timer1 ʱԴ ѡ Fosc  (ʼ Ϊ 4MHz)
					T1PSDIV_4();	 // Timer1ʱԤƵѡ1:4 ( 4MHz  __ T = 1us)

					T2SCKSEL_FOSC();
					T2PSDIV_4();

					// else
					if (new_key == 0x06) //(110)
					{
						temp_cyc = 500; // PWM_output_2kHz
					}
					else if (new_key == 0x07) //(111)
					{
						temp_cyc = 1000; // PWM_output_1kHz
					}
				}

				T2PRLH = temp_cyc >> 8;		// дPWMBڼĴֽ
				T2PRLL = temp_cyc & 0x00ff; // дPWMBڼĴֽ

				T1PRLH = temp_cyc >> 8;		// дPWMAڼĴֽ
				T1PRLL = temp_cyc & 0x00ff; // дPWMAڼĴֽ
			}
		}
	}
	else
	{

		old_key = new_key;		// 
		key_debunce_ctr = 0x00; // 0
		flag_key = FALSE;		// ־0
	}
}

/*******************************************************************
;
;: delay
;
;˵:	ʱӳ
;
********************************************************************/

void delay(unsigned char i)
{
	while (i--)
		;
}

/*******************************************************************
;
;: ISR
;
;˵:	жϷ
;
********************************************************************/
// void ISR(void) __interrupt 		//YSDCC  жϺ
void interrupt ISR(void) // PICC  жϺ
{

	if (TIF == 1)
	{
		TIF = 0; // T0 Զع Ҫóʼֵ

		PORTC ^= 0x01; // Timer0 ʱ 2msж	PC0 ȡ
		flag_t0 = TRUE;
	}
	/*
		if(PWMAF == 1)
		{
			PWMAF = 0;

		}

		if(PWMBF == 1)
		{
			PWMBF = 0;

		}
	*/
}

/*******************************************************************
;
;: Init_GPIO

;˵:	ʼIO
;
********************************************************************/

void Init_GPIO(void)
{
	ADINA = 0x00; // PAģ/IO 		1:ģ⹦		0:I/O
	ADINC = 0x00; // PCģ/IO 		1:ģ⹦		0:I/O

	CPIOA = 0b00001000; // PA          1:		0:
	CPIOC = 0b01000110; // PC          1:		0:

	PAPHR = 0x00; // PAλ			1:ʹ		0:ֹ
	PAPDR = 0x00; // PAλ			1:ʹ		0:ֹ

	PCPHR = 0b01000110; // PCλ			1:ʹ		0:ֹ
	PCPDR = 0x00;		// PCλ			1:ʹ		0:ֹ

	PAINTR = 0x00; // PAƽ仯жλ		1:ʹ		0:ֹ

	PORTA = 0x00; // PAȫ"L"
	PORTC = 0x00; // PCȫ"L"
}

/*******************************************************************
;
;: Init_Timer0_WDT

;˵:	ʼTimer0WDT
;
********************************************************************/

void Init_Timer0_WDT(void)
{
	TCS = 0;	 // TMR0ʱԴѡλ		1:PA2/T0CKIźŵ		0:ڲָʱӣ Fosc/4
	T0PSDIV_8(); // Timer0ԤƵѡ1:8	8us	(Fosc = 4MHz)  (Fcpu = Fosc/4 = 1MHz)
	TMR0 = 6;	 // 250 = 256 - 6		2ms = 250 * 8us
	TMR0EN = 1;	 // Tiemr0 /ֹͣλ	1:Timer0		0:ֹͣTimer0

	//	WDTDIV_512();
	WDTDIV_32768(); // WDT
	SWDTEN = 1;		// Źʹ
}

/*******************************************************************
;
;: Init_Timer1

;˵:	ʼTimer1
;
********************************************************************/
void Init_Timer1(void)
{

	T1GINV = 0; // Timer1ſطתλ				0: Timer1ſΪ͵ƽЧſΪ͵ƽʱTimer1
	//	T1GINV = 1;     //Timer1ſطתλ				1: Timer1ſΪߵƽЧſΪߵƽʱTimer1

	TMR1GE = 0; // Timer1ſʹλ				0: Timer1
	//	TMR1GE = 1;     //Timer1ſʹλ				1: Timer1Timer1ſزʱ

	T1SCKSEL_16MHZ(); // Timer1 ʱԴ ѡڲʱ 16MHz
	T1PSDIV_1();	  // Timer1ʱԤƵѡ1:1 ( 16MHz  __ T = 0.0625us)

	T1SYNC = 0; // Timer1ⲿʱͬλ	0: ͬⲿʱ
	//	T1SYNC = 1;      //Timer1ⲿʱͬλ		1: ͬⲿʱ

	TMR1H = 0x00; // timer1ʱֽ
	TMR1L = 0x00; // timer1ʱֽ

	TMR1ON = 1; // Timer1/ֹͣλ 	1:  Timer1		0: ֹͣTimer1
}
/*******************************************************************
;
;: Init_Timer2

;˵:	ʼTimer2
;
********************************************************************/
void Init_Timer2(void)
{
	T2GINV = 0; // Timer2ſطתλ				0: Timer2ſΪ͵ƽЧſΪ͵ƽʱTimer2
	//	T2GINV = 1; 	//Timer2ſطתλ				1: Timer2ſΪߵƽЧſΪߵƽʱTimer2

	TMR2GE = 0; // Timer2ſʹλ				0: Timer2
	//	TMR2GE = 1; 	//Timer2ſʹλ				1: Timer2Timer2ſزʱ

	T2SCKSEL_16MHZ(); // Timer2 ʱԴ ѡڲʱ 16MHz
	T2PSDIV_1();	  // Timer2ʱԤƵѡ1:1 ( 16MHz  __ T = 0.0625us)

	T2SYNC = 0; // Timer2ⲿʱͬλ		0: ͬⲿʱ
	//	T2SYNC = 1; 	//Timer2ⲿʱͬλ		1: ͬⲿʱ

	TMR2H = 0x00; // timer2ʱֽ
	TMR2L = 0x00; // timer2ʱֽ

	TMR2ON = 1; // Timer2/ֹͣλ 	1:  Timer2		0: ֹͣTimer2
}

/*******************************************************************
;
;: Init_INT

;˵:	ʼ ж
;
********************************************************************/

void Init_INT(void)
{
	INTS = 0x00; // жؼĴ 

	TIF = 0; // timer0жϱ־
	TIS = 1; // ʹ T0ж

	PWMAF = 0;
	//	PWMAIE = 1;		//ʹ Timer1PWMж		õ PWMж ͬʱʹ PWMжϡжϡж

	PWMBF = 0;
	//	PWMBIE = 1;		//ʹ Timer2PWMж		õ PWMж ͬʱʹ PWMжϡжϡж

	//	PEIE = 1;		//ʹ  ж
	GIE = 1; // ʹ  ж
}

/*******************************************************************
;
;: Init_PWM

;˵:	ʼPWMģ
;
********************************************************************/

void Init_PWM(void)
{

	/*	PWMA0PWMA1  ʱԴ Timer1 
		· PWM  ͬ ÿ· PWM ռձȵɵ
		ҪPWMB0/1ʱҪTimer1ʱҪTiemr1ؼĴ
	*/
	PWMA0OL = 0;	   // PWMA0 
	PWMA0SEL_PC5OUT(); // PWMA0ѡ PC5		(PWMA0 ѡ  PC5PA0 ֮һ )
	//	PWMA0SEL_PA0OUT();	//PWMA0ѡ PA0
	//	PWMA0OUTOFF();		//PWMA0ֹ
	PWMA0OUTON(); // PWMA0ʹ

	PWMA1OL = 0;	   // PWMA1 
	PWMA1SEL_PC4OUT(); // PWMA1ѡ PC4		(PWMA1 ѡ  PC4PA1 ֮һ )
	//	PWMA1SEL_PA1OUT();	//PWMA1ѡ PA1
	//	PWMA1OUTOFF();		//PWMA1ֹ
	PWMA1OUTON(); // PWMA1ʹ

	/*	PWMB0PWMB1  ʱԴ Timer2 
		· PWM  ͬ ÿ· PWM ռձȵɵ
		ҪPWMB0/1ʱҪTimer2ʱҪTiemr2ؼĴ
	*/
	PWMB0OL = 0;	   // PWMB0 
	PWMB0SEL_PC3OUT(); // PWMB0ѡ PC3		(PWMB0 ѡ  PC3PA2 ֮һ )
	//	PWMB0SEL_PA2OUT();	//PWMB0ѡ PA2
	//	PWMB0OUTOFF();		//PWMB0ֹ
	PWMB0OUTON(); // PWMB0ʹ

	PWMB1OL = 0;	   // PWMB1 Բ
	PWMB1SEL_PC0OUT(); // PWMB1ѡ PC0		(PWMB1 ѡ  PC0PA5 ֮һ )
	//	PWMB1SEL_PA5OUT();	//PWMB1ѡ PA5
	//	PWMB1OUTOFF();		//PWMB1ֹ
	PWMB1OUTON(); // PWMB1ʹ

	temp_cyc = 40; // PWM

	T1PRLH = temp_cyc >> 8;		// PWMA0/1  ڼĴĸ4λ__b<3:0>
	T1PRLL = temp_cyc & 0x00ff; // PWMA0/1  ڼĴĵֽڡ

	T2PRLH = temp_cyc >> 8;		// PWMBڸֽ
	T2PRLL = temp_cyc & 0x00ff; // PWMBڵֽ

	temp_duty = temp_cyc >> 2; // 50 %

	EPRA0H = temp_duty >> 8;	 // PWMA0 ռձؼĴ4λ__b<3:0>
	PRLA0L = temp_duty & 0x00ff; // PWMA0 ռձؼĴֽ

	EPRA1H = temp_duty >> 8;	 // PWMA1 ռձؼĴ4λ__b<3:0>
	PRLA1L = temp_duty & 0x00ff; // PWMA1 ռձؼĴֽ

	EPRB0H = temp_duty >> 8;	 // PWMB0 ռձؼĴ4λ__b<3:0>
	PRLB0L = temp_duty & 0x00ff; // PWMB0 ռձؼĴֽ

	EPRB1H = temp_duty >> 8;	 // PWMB1 ռձؼĴ4λ__b<3:0>
	PRLB1L = temp_duty & 0x00ff; // PWMB1 ռձؼĴֽ
}
