/***********************************************************************
;Company : Yspring ------л㴺Ƽɷ޹˾
;File Name :YS274
;Description :  YS274_TIMER_
			  TMR0ʱ2msͨʹPC31Hz
			  timer1ʱ10msͨʹPC42Hz
			  timer2ʱ100msͨʹPC50.25Hz
***********************************************************************/

#include <YS274.h>
#include "cfg.h"

//----------------------------ض----------------------------

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;

//--------------------------------------------------------------

void Init_Timer0_WDT(void); // ʼtimer0WDT
void Init_Timer1(void);		// ʼtimer1
void Init_Timer2(void);		// ʼtimer2
void Init_GPIO(void);		// ʼIO
void Init_INT(void);		// ʼж

//----------------------------궨------------------------------------

#define CLRWDT()       \
	do                 \
	{                  \
		asm("clrwdt"); \
	} while (0)
#define SLEEP()       \
	do                \
	{                 \
		asm("sleep"); \
		asm("NOP");   \
		asm("NOP");   \
		;             \
	} while (0) // asm("clrwdt");asm("clrwdt")

#define T2S 20	   // 2s = 20 * 100ms
#define T1S 100	   // 1s = 100 * 10ms
#define T500MS 250 // 500ms = 250 * 2ms

//--------------------------------------------------------------
u8 Timer_2ms_ctr;	// 2ms
u8 Timer_10ms_ctr;	// 10ms
u8 Timer_100ms_ctr; // 100ms

//---------------------------λ---------------------------------
bit flag_t0 = 0; // 2ms־
bit flag_t1 = 0; // 10ms־
bit flag_t2 = 0; // 100ms־

/***********************************************************************
;
;: main
;
;˵:	
;
***********************************************************************/
void main(void)
{
	CLRWDT(); // 忴Ź

	SET_HIRC(IRCF_4M); // ڲƵѡ4MHz
	Init_Timer0_WDT(); // ʼtimer0WDT
	Init_Timer1();	   // ʼtimer1
	Init_Timer2();	   // ʼtimer2
	Init_GPIO();	   // ʼIO
	Init_INT();		   // ʼж

	//============================ѭ====================================
	while (1)
	{
		CLRWDT(); //  Ź

		if (flag_t0 == 1) // 2msж
		{
			flag_t0 = 0; // 2ms־0

			Timer_2ms_ctr++;			 // 2ms 1
			if (Timer_2ms_ctr >= T500MS) // 500msж
			{
				Timer_2ms_ctr = 0x00; // 2ms0

				PORTC ^= 0x08; // PC3 	500ms ȡ
			}
		}

		if (flag_t1 == 1) // 10msж
		{
			flag_t1 = 0; // 10ms־0

			Timer_10ms_ctr++;		   // 10ms 1
			if (Timer_10ms_ctr >= T1S) // 1sж
			{
				Timer_10ms_ctr = 0x00; // 10ms0

				PORTC ^= 0x010; // PC4 	1s ȡ
			}
		}

		if (flag_t2 == 1) // 100msж
		{
			flag_t2 = 0; // 100ms־0

			Timer_100ms_ctr++;			// 100ms1
			if (Timer_100ms_ctr >= T2S) // 2sж
			{
				Timer_100ms_ctr = 0x00; // 100ms0

				PORTC ^= 0x20; // PC5 	2s ȡ
			}
		}
	}
}

/***********************************************************************
;
;: ISR
;
;˵:	жϷ
;
***********************************************************************/
void interrupt ISR(void) // PICC  жϺ
{

	if (TIF == 1) // timer0 ʱж ж
	{
		TIF = 0; // T0жϱ־0

		PORTC ^= 0x01; // Timer0 ʱ 2msж	PC0 ȡ
		flag_t0 = 1;   // 2ms־1
	}

	if (TMR1IF == 1) // tmr1жж
	{
		TMR1IF = 0; // tmr1жϱ־0

		TMR1ON = 0;	  // ֹtmr1
		TMR1H = 0x63; // 25536 = 65536 - 40000	(0x63c0 = 25536)
		TMR1L = 0xc0; // 10ms = 40000 * 0.25us	( Fosc = 4MHz  __ T = 0.25us)
		TMR1ON = 1;	  // ʹtmr1

		PORTC ^= 0x02; // Timer1 ʱ 10msж	PC1 ȡ
		flag_t1 = 1;   // 10ms־1
	}

	if (TMR2IF == 1) // timer2жж
	{
		TMR2IF = 0; // timer2жϱ־0

		TMR2ON = 0;	  // T2óʼֵ
		TMR2H = 0x3c; // 15536 = 65536 - 50000	(0x3cb0 = 15536)
		TMR2L = 0xb0; // 100ms = 50000 * 2us
		TMR2ON = 1;

		PORTC ^= 0x04; // Timer2 ʱ100msж	PC2 ȡ
		flag_t2 = 1;   // 100ms־1
	}
}

/***********************************************************************
;
;: Init_GPIO

;˵:	ʼIO
;
***********************************************************************/

void Init_GPIO(void)
{
	ADINA = 0x00; // PAģ/IO 		1:ģ⹦		0:I/O
	ADINC = 0x00; // PCģ/IO 		1:ģ⹦		0:I/O

	CPIOA = 0b00001000; // PA		1:		0:
	CPIOC = 0b00000000; // PC		1:		0:

	PAPHR = 0x00; // PAλ			1:ʹ		0:ֹ
	PAPDR = 0x00; // PAλ			1:ʹ		0:ֹ

	PCPHR = 0x00; // PCλ			1:ʹ		0:ֹ
	PCPDR = 0x00; // PCλ			1:ʹ		0:ֹ

	PAINTR = 0x00; // PAƽ仯жλ		1:ʹ		0:ֹ

	PORTA = 0x00; // PAȫ"L"
	PORTC = 0x00; // PCȫ"L"
}

/***********************************************************************
;
;: Init_Timer0_WDT

;˵:	ʼTimer0WDT
;
***********************************************************************/

void Init_Timer0_WDT(void)
{
	TCS = 0;	 // TMR0ʱԴѡλ		1:PA2/T0CKIźŵ		0:ڲָʱӣ Fosc/4
	T0PSDIV_8(); // Timer0ԤƵѡ1:8	8us	(Fosc = 4MHz)  (Fcpu = Fosc/4 = 1MHz)
	TMR0 = 6;	 // 250 = 256 - 6		2ms = 250 * 8us
	TMR0EN = 1;	 // Tiemr0 /ֹͣλ	1:Timer0		0:ֹͣTimer0

	//	WDTDIV_512();
	WDTDIV_32768(); // WDT
	SWDTEN = 1;		// ʹWDTOPTIONdisable WDTʱЧ
}

/***********************************************************************
;
;: Init_Timer1

;˵:	ʼTimer1
;
***********************************************************************/
void Init_Timer1(void)
{

	T1SELEN = 0; // Timer1 ʱԴѡλ				0: Timer1 ʱԴTMR1CSλȷ
	//	T1SELEN = 1;	//Timer1 ʱԴѡλ				1: Timer1 ʱԴ T1FOSCλȷ

	T1FOSC = 0; // Timer1 ʱԴѡڲʱʹλ 	0: Timer1 ʱԴѡڲ " ʱ " 	( T1SELEN = 1ʱ)
	//	T1FOSC = 1; //Timer1 ʱԴѡڲʱʹλ 	1: Timer1 ʱԴѡڲ " ʱ " ( T1SELEN = 1ʱ)

	T1GINV = 0; // Timer1ſطתλ					0: Timer1ſΪ͵ƽЧſΪ͵ƽʱTimer1
	//	T1GINV = 1; 	//Timer1ſطתλ				1: Timer1ſΪߵƽЧſΪߵƽʱTimer1

	TMR1GE = 0; // Timer1ſʹλ					0: Timer1
	//	TMR1GE = 1; 	//Timer1ſʹλ				1: Timer1Timer1ſزʱ

	T1PSDIV_1(); // Timer1ʱԤƵѡ1:1	( Fosc = 4MHz  __ T = 0.25us)

	T1SYNC = 0; // Timer1ⲿʱͬλ		0: ͬⲿʱ
	//	T1SYNC = 1; 	//Timer1ⲿʱͬλ		1: ͬⲿʱ

	TMR1CS = 0; // Timer1ʱԴѡλ			0: ڲʱӣFOSC
	//	TMR1CS = 1; 	//Timer1ʱԴѡλ			1: T12CK1ţأⲿʱ

	T1OSCEN = 0; // LPʹܿλ			0:	LPر
	//	T1OSCEN = 1;	//LPʹܿλ			1:	LPʹTimer1ʱ

	TMR1H = 0x63; // 25536 = 65536 - 40000	(0x63c0 = 25536)
	TMR1L = 0xc0; // 10ms = 40000 * 0.25us	( Fosc = 4MHz  __ T = 0.25us)

	TMR1ON = 1; // Timer1/ֹͣλ		1:  Timer1		0: ֹͣTimer1
}
/***********************************************************************
;
;: Init_Timer2

;˵:	ʼTimer2
;
***********************************************************************/
void Init_Timer2(void)
{

	T2SELEN = 0; // Timer2 ʱԴѡλ					0: Timer2 ʱԴTMR2CSλȷ
	//	T2SELEN = 1;	//Timer2 ʱԴѡλ					1: Timer2 ʱԴ T2FOSCλȷ

	T2FOSC = 0; // Timer2 ʱԴѡڲʱʹλ 		0: Timer2 ʱԴѡڲ " ʱ " 	( T2SELEN = 1ʱ)
	//	T2FOSC = 1; //Timer2 ʱԴѡڲʱʹλ 	1: Timer2 ʱԴѡڲ " ʱ " ( T2SELEN = 1ʱ)

	T2GINV = 0; // Timer2ſطתλ					0: Timer2ſΪ͵ƽЧſΪ͵ƽʱTimer2
	//	T2GINV = 1;		//Timer2ſطתλ				1: Timer2ſΪߵƽЧſΪߵƽʱTimer2

	TMR2GE = 0; // Timer2ſʹλ					0: Timer2
	//	TMR2GE = 1;		//Timer2ſʹλ				1: Timer2Timer2ſزʱ

	T2PSDIV_8(); // Timer2ʱԤƵѡ1:8	( Fosc = 4MHz  __ T = 2us)

	T2SYNC = 0; // Timer2ⲿʱͬλ		0: ͬⲿʱ
	//	T2SYNC = 1;		//Timer2ⲿʱͬλ		1: ͬⲿʱ

	TMR2CS = 0; // Timer2ʱԴѡλ			0: ڲʱӣSYS_CLK
	//	TMR2CS = 1;		//Timer2ʱԴѡλ			1: T12CK1ţأⲿʱ

	T2OSCEN = 0; // LPʹܿλ			0:  LPر
	//	T2OSCEN = 1;	//LPʹܿλ			1:  LPʹTimer2ʱ

	TMR2H = 0x3c; // 15536 = 65536 - 50000	(0x3cb0 = 15536)
	TMR2L = 0xb0; // 100ms = 50000 * 2us

	TMR2ON = 1; // Timer2/ֹͣλ		1:  Timer2		0: ֹͣTimer2
}

/***********************************************************************
;
;: Init_INT

;˵:	ʼ ж
;
***********************************************************************/

void Init_INT(void)
{

	INTS = 0x00; // жؼĴ 

	TIF = 0; // TMR0жϱ־
	TIS = 1; // ʹ T0ж

	TMR1IF = 0;
	TMR1IE = 1; // ʹ  T1ж		õ T1ж ͬʱʹ T1жϡжϡж

	TMR2IF = 0;
	TMR2IE = 1; // ʹ  T2ж		õ T2ж ͬʱʹ T2жϡжϡж

	PEIE = 1; // ʹ  ж
	GIE = 1;  // ʹ  ж
}

/***********************************************************************

***********************************************************************/
